Index: LMDZ5/branches/testing/libf/phylmd/Dust/finemission.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/finemission.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/finemission.F	(revision 2641)
@@ -0,0 +1,144 @@
+C This subroutine calculates the emissions of BLACK CARBON and ORGANIC
+C MATTER
+      SUBROUTINE finemission(zdz,pdtphys,zalt,kminbc,kmaxbc,
+     .                       scale_param_bb,scale_param_ff,
+     .                       iregion_ind,iregion_bb,
+     .                       nbreg_ind,nbreg_bb,
+     .                       lmt_bcff,lmt_bcnff,lmt_bcbb_l,lmt_bcbb_h,
+     .                       lmt_bcba,lmt_omff,lmt_omnff,lmt_ombb_l,
+     .                       lmt_ombb_h,lmt_omnat,lmt_omba,id_fine,
+     .                                    flux_sparam_bb,flux_sparam_ff,
+     .                                        source_tr,flux_tr,tr_seri)
+
+      USE dimphy
+      USE indice_sol_mod
+      USE infotrac
+!      USE phytracr_spl_mod, ONLY : nbreg_dust, nbreg_ind, nbreg_bb
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "paramet.h"
+
+      INTEGER i, k, kminbc, kmaxbc
+c============================= INPUT ===================================
+      REAL pdtphys  ! pas d'integration pour la physique (seconde)
+      REAL zalt(klon,klev)
+      REAL zdz(klon,klev)
+c
+c------------------------- Scaling Parameters --------------------------
+c   
+      INTEGER nbreg_ind,nbreg_bb
+      INTEGER iregion_ind(klon)  !Defines regions for SO2, BC & OM
+      INTEGER iregion_bb(klon)   !Defines regions for SO2, BC & OM
+      REAL scale_param_bb(nbreg_bb) !Scaling parameter for biomas burning
+      REAL scale_param_ff(nbreg_ind) !Scaling parameter for industrial emissions (fossil fuel)
+      INTEGER id_fine
+c============================= OUTPUT ==================================
+      REAL source_tr(klon,nbtr)
+      REAL flux_tr(klon,nbtr)
+      REAL tr_seri(klon,klev,nbtr) ! traceur
+      REAL flux_sparam_bb(klon), flux_sparam_ff(klon)
+c========================= LOCAL VARIABLES =============================
+      REAL zzdz
+c------------------------- BLACK CARBON emissions ----------------------
+      REAL lmt_bcff(klon)       ! emissions de BC fossil fuels
+      REAL lmt_bcnff(klon)      ! emissions de BC non-fossil fuels
+      REAL lmt_bcbb_l(klon)     ! emissions de BC biomass basses
+      REAL lmt_bcbb_h(klon)     ! emissions de BC biomass hautes
+      REAL lmt_bcba(klon)       ! emissions de BC bateau
+c------------------------ ORGANIC MATTER emissions ---------------------
+      REAL lmt_omff(klon)     ! emissions de OM fossil fuels
+      REAL lmt_omnff(klon)    ! emissions de OM non-fossil fuels
+      REAL lmt_ombb_l(klon)   ! emissions de OM biomass basses
+      REAL lmt_ombb_h(klon)   ! emissions de OM biomass hautes
+      REAL lmt_omnat(klon)    ! emissions de OM Natural
+      REAL lmt_omba(klon)     ! emissions de OM bateau
+                                
+      EXTERNAL condsurfc                                
+c========================================================================
+c                        LOW LEVEL EMISSIONS
+c========================================================================
+            
+c corresponds to bc_source.EQ.3
+
+      DO i=1,klon
+         IF (iregion_ind(i).GT.0) THEN
+       IF(id_fine>0)    source_tr(i,id_fine)=source_tr(i,id_fine)+
+     .                (scale_param_ff(iregion_ind(i))*lmt_bcff(i)+     !g/m2/s
+     .                 scale_param_ff(iregion_ind(i))*lmt_omff(i)
+     .                 )     * 1.e4                        !g/m2/s
+c
+      IF(id_fine>0)     flux_tr(i,id_fine)=flux_tr(i,id_fine)+
+     .                (scale_param_ff(iregion_ind(i))*lmt_bcff(i)+     !mg/m2/s
+     .                 scale_param_ff(iregion_ind(i))*lmt_omff(i)
+     .                 )     * 1.e4 *1.e3                  !mg/m2/s
+c
+           flux_sparam_ff(i)= flux_sparam_ff(i) +
+     .                     scale_param_ff(iregion_ind(i))*
+     .                     ( lmt_bcff(i)+lmt_omff(i))
+     .                     *1.e4*1.e3
+         ENDIF
+         IF (iregion_bb(i).GT.0) THEN
+       IF(id_fine>0)    source_tr(i,id_fine)=source_tr(i,id_fine)+
+     .                (scale_param_bb(iregion_bb(i))*lmt_bcbb_l(i)+   !g/m2/s
+     .                 scale_param_bb(iregion_bb(i))*lmt_ombb_l(i)    !g/m2/s
+     .                 )     * 1.e4                        !g/m2/s
+c
+       IF(id_fine>0)    flux_tr(i,id_fine)=flux_tr(i,id_fine)+
+     .                (scale_param_bb(iregion_bb(i))*lmt_bcbb_l(i)+   !mg/m2/s
+     .                 scale_param_bb(iregion_bb(i))*lmt_ombb_l(i)+   !mg/m2/s
+     .                 scale_param_bb(iregion_bb(i))*lmt_bcbb_h(i)+   !mg/m2/s
+     .                 scale_param_bb(iregion_bb(i))*lmt_ombb_h(i)    !mg/m2/s
+     .                 )     * 1.e4 *1.e3                  !mg/m2/s
+c
+           flux_sparam_bb(i)=flux_sparam_bb(i) +
+     .                   scale_param_bb(iregion_bb(i))*(lmt_bcbb_l(i) +
+     .                   lmt_bcbb_h(i) + lmt_ombb_l(i) + lmt_ombb_h(i))
+     .                   *1.e4*1.e3
+         ENDIF
+       IF(id_fine>0)  source_tr(i,id_fine)=source_tr(i,id_fine)+
+     .                (lmt_bcnff(i)+lmt_bcba(i)+lmt_omnff(i)+
+     .                 lmt_omnat(i)+lmt_omba(i))     * 1.e4           !g/m2/s
+c
+       IF(id_fine>0)  flux_tr(i,id_fine)=flux_tr(i,id_fine)+
+     .                (lmt_bcnff(i)+lmt_omnff(i)+lmt_omnat(i)+
+     .                 lmt_omba(i)+lmt_bcba(i))     * 1.e4 *1.e3      !mg/m2/s
+c
+         flux_sparam_ff(i)= flux_sparam_ff(i) + 
+     .                      (lmt_omba(i)+lmt_bcba(i))*1.e4*1.e3
+      ENDDO
+
+c========================================================================
+c                        HIGH LEVEL EMISSIONS
+c========================================================================
+                             
+c  Sources hautes de BC/OM
+
+c
+c HIGH LEVEL EMISSIONS OF SO2 ARE IN PRECUREMISSION.F
+c
+      k=2                             !introducing emissions in level 2
+cnhl      DO i = 1, klon
+c
+cnhl      tr_seri(i,k,id_fine)=tr_seri(i,k,id_fine)+scale_param_ff(iregion_ind(i))*
+cnhl     .               (lmt_bcff_h(i)+lmt_omff_h(i))/zdz(i,k)/100.*pdtphys
+c
+cnhl      ENDDO
+
+      DO k=kminbc, kmaxbc
+      DO i = 1, klon
+          zzdz=zalt(i,kmaxbc+1)-zalt(i,kminbc)
+c
+         IF (iregion_bb(i) .GT.0) THEN
+        IF(id_fine>0)   tr_seri(i,k,id_fine)=tr_seri(i,k,id_fine)+
+     .              (scale_param_bb(iregion_bb(i))*lmt_bcbb_h(i)+
+     .               scale_param_bb(iregion_bb(i))*lmt_ombb_h(i))
+     .                              /zzdz/100.*pdtphys
+         ENDIF
+c
+      ENDDO
+      ENDDO
+c
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/gastoparticle.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/gastoparticle.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/gastoparticle.F	(revision 2641)
@@ -0,0 +1,92 @@
+      SUBROUTINE gastoparticle(pdtphys,zdz,zrho,xlat,pplay,t_seri,
+     .         id_prec,id_fine,
+     .         tr_seri,his_g2pgas ,his_g2paer )
+cnhl     .                         fluxso4chem, flux_sparam_sulf,
+
+      USE dimphy
+      USE infotrac
+c      USE indice_sol_mod
+
+      IMPLICIT NONE 
+c
+#include "dimensions.h"
+#include "chem.h"
+#include "chem_spla.h"
+#include "YOMCST.h"
+#include "YOECUMF.h"
+c
+      REAL pdtphys
+      REAL zrho(klon,klev)
+      REAL zdz(klon,klev)
+      REAL tr_seri(klon,klev,nbtr)   ! traceurs
+      REAL tend                 ! tendance par espece
+      REAL xlat(klon)       ! latitudes pour chaque point
+      REAL pi
+c   JE: 20140120
+      REAL his_g2pgas(klon)
+      REAL his_g2paer(klon)
+      REAL tendincm3(klon,klev)
+      REAL tempvar(klon,klev)      
+      REAL pplay(klon,klev)
+      REAL t_seri(klon,klev)
+      REAL tend2d(klon,klev)
+      INTEGER id_prec,id_fine
+c
+c------------------------- Scaling Parameter --------------------------
+c
+c      REAL scale_param_so4(klon)  !Scaling parameter for sulfate
+
+      INTEGER i, k
+      REAL tau_chem     !---chemical lifetime in s
+c
+c------------------------- Variables to save --------------------------
+c
+cnhl      REAL fluxso4chem(klon,klev)
+cnhl      REAL flux_sparam_sulf(klon,klev)
+
+c======================================================================
+      pi=atan(1.)*4.
+c
+      IF (id_prec>0 .AND. id_fine>0) THEN
+      DO k = 1, klev
+      DO i = 1, klon
+c
+c        tau_chem=scale_param_so4(i)*86400.*(8.-5.*cos(xlat(i)*pi/180.))    !tchemfctn2
+cnhl        tau_chem=86400.*(8.-5.*cos(xlat(i)*pi/180.))    !tchemfctn2
+        tau_chem=86400.*(5.-4.*cos(xlat(i)*pi/180.))    !
+        tend=tr_seri(i,k,id_prec)*(1.-exp(-pdtphys/tau_chem)) ! Sulfate production
+cnhl        tend=(1.-exp(-pdtphys/tau_chem))
+cnhl        tend=scale_param_so4(i) !as this it works
+c      
+        tr_seri(i,k,id_prec) =tr_seri(i,k,id_prec) - tend
+        tr_seri(i,k,id_fine) =tr_seri(i,k,id_fine) + 
+     .                      tend/RNAVO*masse_ammsulfate  !--gAER/KgAir
+        tend2d(i,k)=tend
+c
+cnhl        fluxso4chem(i,k) = tend/RNAVO*masse_ammsulfate
+cnhl        flux_sparam_sulf(i,k) = tend/RNAVO*masse_ammsulfate
+      ENDDO
+      ENDDO
+   
+
+
+        tempvar=tend2d
+         CALL kg_to_cm3(pplay,t_seri,tempvar)
+        tendincm3=tempvar
+
+      DO k = 1, klev
+      DO i = 1, klon
+
+c        his_g2pgas(i) = his_g2pgas(i) + tendincm3(i,k)*1e6*zdz(i,k)/pdtphys
+        his_g2paer(i) = his_g2paer(i) +      
+     .    tendincm3(i,k)/RNAVO*masse_ammsulfate*1.e3*
+     .    1.e6*zdz(i,k)/pdtphys    ! mg/m2/s
+        his_g2pgas(i) = his_g2paer(i)*masse_s/masse_ammsulfate ! mg-S/m2/s
+
+      ENDDO
+      ENDDO
+      ENDIF
+
+c
+      RETURN 
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/incloud_scav.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/incloud_scav.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/incloud_scav.F	(revision 2641)
@@ -0,0 +1,100 @@
+c Subroutine that calculates the effect of precipitation in scavenging 
+c WITHIN the cloud, for large scale as well as convective precipitation
+      SUBROUTINE incloud_scav(lminmax,qmin,qmax,masse,henry,kk,prfl,
+     .                      psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,
+     .                                   his_dhlsc,his_dhcon1,tr_seri)
+
+      USE dimphy
+      USE infotrac
+      USE indice_sol_mod
+
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "paramet.h"
+
+c============================= INPUT ===================================
+      REAL qmin, qmax
+      REAL masse(nbtr)
+      REAL henry(nbtr)         !--cste de Henry  mol/l/atm
+      REAL kk(nbtr)            !--coefficient de var avec T (K)
+      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale
+!      REAL prfl(klon,klev),   psfl(klon,klev)     !--large-scale
+      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection
+!      REAL pmflxr(klon,klev), pmflxs(klon,klev)   !--convection
+      REAL zrho(klon,klev), zdz(klon,klev)
+      REAL t_seri(klon,klev)
+      LOGICAL lminmax
+      REAL pdtphys
+!      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale  ! Titane
+!      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection   ! Titane
+c============================= OUTPUT ==================================
+      REAL tr_seri(klon,klev,nbtr) ! traceur
+      REAL aux_var1(klon,klev) ! traceur
+      REAL aux_var2(klon) ! traceur
+      REAL aux_var3(klon) ! traceur
+      REAL his_dhlsc(klon,nbtr)        ! in-cloud scavenging lsc
+      REAL his_dhcon1(klon,nbtr)       ! in-cloud scavenging con
+c========================= LOCAL VARIABLES =============================      
+      INTEGER it, i, j
+      
+      EXTERNAL minmaxqfi, inscav_spl
+      
+      DO it=1, nbtr
+c
+      DO i=1,klon
+        aux_var2(i)=his_dhlsc(i,it)
+        aux_var3(i)=his_dhcon1(i,it)
+      ENDDO
+      DO j=1,klev
+      DO i=1,klon
+        aux_var1(i,j)=tr_seri(i,j,it)
+      ENDDO
+      ENDDO
+c      
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'avt inscav')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'avt inscav')
+      ENDIF
+c
+cnhl      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),0.5e-3,
+cnhl     .             prfl,psfl,zrho,zdz,t_seri,tr_seri(1,1,it),
+cnhl     .             his_dhlsc(1,it))
+      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),0.5e-3,
+     .             prfl,psfl,zrho,zdz,t_seri,aux_var1,aux_var2)
+c
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide lsc')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide lsc')
+      ENDIF
+c
+c
+c-scheme for convective in-cloud scavenging
+c
+cnhl      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),1.e-3,
+cnhl     .             pmflxr,pmflxs,zrho,zdz,t_seri,tr_seri(1,1,it),
+cnhl     .             his_dhcon1(1,it))
+      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),1.e-3,
+     .             pmflxr,pmflxs,zrho,zdz,t_seri,aux_var1,aux_var3)
+c
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide con')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide con')
+      ENDIF
+c
+      DO j=1,klev
+      DO i=1,klon
+        tr_seri(i,j,it)=aux_var1(i,j)
+      ENDDO
+      ENDDO
+      DO i=1,klon
+        his_dhlsc(i,it)=aux_var2(i)
+        his_dhcon1(i,it)=aux_var3(i)
+      ENDDO
+
+c
+      ENDDO !--boucle sur it
+
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/incloud_scav_lsc.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/incloud_scav_lsc.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/incloud_scav_lsc.F	(revision 2641)
@@ -0,0 +1,112 @@
+c Subroutine that calculates the effect of precipitation in scavenging 
+c WITHIN the cloud, for large scale as well as convective precipitation
+      SUBROUTINE incloud_scav_lsc(lminmax,qmin,qmax,masse,henry,kk,prfl,
+     .                      psfl,pmflxr,pmflxs,zrho,zdz,t_seri,pdtphys,
+     .                                   his_dhlsc,his_dhcon1,tr_seri)
+
+      USE dimphy
+      USE infotrac
+      USE indice_sol_mod
+
+      IMPLICIT NONE
+
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "paramet.h"
+
+c============================= INPUT ===================================
+      REAL qmin, qmax
+      REAL masse(nbtr)
+      REAL henry(nbtr)         !--cste de Henry  mol/l/atm
+      REAL kk(nbtr)            !--coefficient de var avec T (K)
+      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale
+!      REAL prfl(klon,klev),   psfl(klon,klev)     !--large-scale
+      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection
+!      REAL pmflxr(klon,klev), pmflxs(klon,klev)   !--convection
+      REAL zrho(klon,klev), zdz(klon,klev)
+      REAL t_seri(klon,klev)
+      LOGICAL lminmax
+      REAL pdtphys
+!      REAL prfl(klon,klev+1),   psfl(klon,klev+1)     !--large-scale  ! Titane
+!      REAL pmflxr(klon,klev+1), pmflxs(klon,klev+1)   !--convection   ! Titane
+c============================= OUTPUT ==================================
+      REAL tr_seri(klon,klev,nbtr) ! traceur
+      REAL aux_var1(klon,klev) ! traceur
+      REAL aux_var2(klon) ! traceur
+      REAL aux_var3(klon) ! traceur
+      REAL his_dhlsc(klon,nbtr)        ! in-cloud scavenging lsc
+      REAL his_dhcon1(klon,nbtr)       ! in-cloud scavenging con
+c========================= LOCAL VARIABLES =============================      
+      INTEGER it, i, j
+      
+      EXTERNAL minmaxqfi, inscav_spl
+      DO it=1, nbtr
+c
+      DO i=1,klon
+        aux_var2(i)=his_dhlsc(i,it)
+        aux_var3(i)=his_dhcon1(i,it)
+      ENDDO
+      DO j=1,klev
+      DO i=1,klon
+        aux_var1(i,j)=tr_seri(i,j,it)
+      ENDDO
+      ENDDO
+c      
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'avt inscav')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'avt inscav')
+      ENDIF
+c
+cnhl      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),0.5e-3,
+cnhl     .             prfl,psfl,zrho,zdz,t_seri,tr_seri(1,1,it),
+cnhl     .             his_dhlsc(1,it))
+      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),0.5e-3,
+     .             prfl,psfl,zrho,zdz,t_seri,aux_var1,aux_var2)
+c
+      IF (lminmax) THEN
+        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide lsc')
+cnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide lsc')
+      ENDIF
+c
+c
+c-scheme for convective in-cloud scavenging
+c
+cnhl      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),1.e-3,
+cnhl     .             pmflxr,pmflxs,zrho,zdz,t_seri,tr_seri(1,1,it),
+cnhl     .             his_dhcon1(1,it))
+
+c      print *,'JE inscav0'
+c      IF (iflag_con.LT.3) THEN
+c
+c      print *,'JE inscav1'
+c      print *,'iflag_con',iflag_con
+c      CALL inscav_spl(pdtphys,it,masse(it),henry(it),kk(it),1.e-3,
+c     .             pmflxr,pmflxs,zrho,zdz,t_seri,aux_var1,aux_var3)
+c
+cc
+c      IF (lminmax) THEN
+c        CALL minmaxqfi(aux_var1,qmin,qmax,'depot humide con')
+ccnhl      CALL minmaxqfi(tr_seri(1,1,it),qmin,qmax,'depot humide con')
+c
+c      ENDIF
+c
+c      ENDIF ! iflag_con
+
+c
+c      print *,'JE inscav2'
+      DO j=1,klev
+      DO i=1,klon
+        tr_seri(i,j,it)=aux_var1(i,j)
+      ENDDO
+      ENDDO
+      DO i=1,klon
+        his_dhlsc(i,it)=aux_var2(i)
+        his_dhcon1(i,it)=aux_var3(i)
+      ENDDO
+
+c
+      ENDDO !--boucle sur it
+
+c      print *,'JE inscav3'
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/inscav_spl.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/inscav_spl.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/inscav_spl.F	(revision 2641)
@@ -0,0 +1,140 @@
+      SUBROUTINE inscav_spl(pdtime,it,masse,henry,kk,qliq,
+     .                   flxr,flxs,zrho,zdz,t,x,
+     .                   his_dh) 
+      USE dimphy
+      IMPLICIT NONE 
+c=====================================================================
+c Objet : depot humide de traceurs
+c Date : mars 1998
+c Auteur: O. Boucher (LOA) 
+c=====================================================================
+c
+#include "dimensions.h"
+#include "chem.h"
+#include "YOMCST.h"
+#include "YOECUMF.h" 
+c
+      INTEGER it
+      REAL pdtime              ! pas de temps (s)
+      REAL masse               ! molar mass (except for BC/OM/IF/DUST=Nav)
+      REAL henry               ! constante de Henry en mol/l/atm
+      REAL kk                  ! coefficient de dependence en T (K)
+      REAL qliq                ! contenu en eau liquide dans le nuage (kg/kg)
+!      REAL flxr(klon,klev+1)   ! flux precipitant de pluie
+!      REAL flxs(klon,klev+1)   ! flux precipitant de neige
+      REAL flxr(klon,klev)   ! flux precipitant de pluie   ! Titane
+      REAL flxs(klon,klev)   ! flux precipitant de neige   ! Titane
+      REAL flxr_aux(klon,klev+1)
+      REAL flxs_aux(klon,klev+1)
+      REAL zrho(klon,klev)
+      REAL zdz(klon,klev)
+      REAL t(klon,klev)
+      REAL x(klon,klev)        ! q de traceur  
+      REAL his_dh(klon)        ! tendance de traceur integre verticalement
+c
+c--variables locales      
+      INTEGER i, k
+c
+      REAL dx      ! tendance de traceur
+      REAL f_a     !--rapport de la phase aqueuse a la phase gazeuse
+      REAL beta    !--taux de conversion de l'eau en pluie
+      REAL henry_t !--constante de Henry a T t  (mol/l/atm)
+      REAL scav(klon,klev)    !--fraction aqueuse du constituant
+      REAL K1, K2, ph, frac 
+      REAL frac_gas, frac_aer !-cste pour la reevaporation 
+      PARAMETER (ph=5., frac_gas=1.0, frac_aer=0.5)
+c---cste de dissolution pour le depot humide
+      REAL frac_fine_scav,frac_coar_scav
+c---added by nhl
+      REAL aux_cte
+
+      PARAMETER (frac_fine_scav=0.7)
+      PARAMETER (frac_coar_scav=0.7)
+
+c--101.325  m3/l x Pa/atm
+c--R        Pa.m3/mol/K
+c
+c------------------------------------------
+c
+cnhl      IF (it.EQ.2.OR.it.EQ.3) THEN !--aerosol  ! AS IT WAS FIRST
+      IF (it.EQ.2.OR.it.EQ.3.OR.it.EQ.4) THEN !--aerosol
+        frac=frac_aer
+      ELSE                                                !--gas
+        frac=frac_gas
+      ENDIF
+c
+      IF (it.EQ.1) THEN 
+      DO k=1, klev
+      DO i=1, klon 
+        henry_t=henry*exp(-kk*(1./298.-1./t(i,k)))    !--mol/l/atm
+        K1=1.2e-2*exp(-2010*(1/298.-1/t(i,k)))
+        K2=6.6e-8*exp(-1510*(1/298.-1/t(i,k)))
+        henry_t=henry_t*(1 + K1/10.**(-ph) + K1*K2/(10.**(-ph))**2)
+        f_a=henry_t/101.325*R*t(i,k)*qliq*zrho(i,k)/rho_water
+        scav(i,k)=f_a/(1.+f_a)
+      ENDDO 
+      ENDDO
+      ELSEIF (it.EQ.2) THEN
+      DO k=1, klev
+      DO i=1, klon 
+        scav(i,k)=frac_fine_scav
+      ENDDO 
+      ENDDO
+      ELSEIF (it.EQ.3) THEN
+      DO k=1, klev
+      DO i=1, klon 
+        scav(i,k)=frac_coar_scav
+      ENDDO 
+      ENDDO 
+      ELSEIF (it.EQ.4) THEN
+      DO k=1, klev
+      DO i=1, klon 
+        scav(i,k)=frac_coar_scav
+      ENDDO 
+      ENDDO 
+      ELSE 
+        PRINT *,'it non pris en compte'
+        STOP
+      ENDIF
+c
+! NHL
+! Auxiliary variables defined to deal with the fact that precipitation
+! fluxes are defined on klev levels only.
+! NHL
+!
+      flxr_aux(:,klev+1)=0.0
+      flxs_aux(:,klev+1)=0.0
+      flxr_aux(:,1:klev)=flxr(:,:)
+      flxs_aux(:,1:klev)=flxs(:,:)
+      DO k=klev, 1, -1 
+      DO i=1, klon 
+c--scavenging
+        beta=flxr_aux(i,k)-flxr_aux(i,k+1)+flxs_aux(i,k)-flxs_aux(i,k+1)
+        beta=beta/zdz(i,k)/qliq/zrho(i,k)
+        beta=MAX(0.0,beta)
+        dx=x(i,k)*(exp(-scav(i,k)*beta*pdtime)-1.)
+        x(i,k)=x(i,k)+dx
+        his_dh(i)=his_dh(i)-dx/RNAVO*
+     .            masse*1.e3*1.e6*zdz(i,k)/pdtime !--mgS/m2/s
+c--reevaporation
+        beta=flxr_aux(i,k)-flxr_aux(i,k+1)+flxs_aux(i,k)-flxs_aux(i,k+1)
+        IF (beta.LT.0.) beta=beta/(flxr_aux(i,k+1)+flxs_aux(i,k+1))
+        IF (flxr_aux(i,k)+flxs_aux(i,k).EQ.0) THEN  !--reevaporation totale
+          beta=MIN(MAX(0.0,-beta),1.0)
+        ELSE                          !--reevaporation non totale pour aerosols
+          !print *,'FRAC USED IN INSCAV_SPL'
+          beta=MIN(MAX(0.0,-beta)*frac,1.0)
+        ENDIF
+        dx=beta*his_dh(i)*RNAVO/masse/1.e3/1.e6/zdz(i,k)*pdtime !ORIG LINE
+! funny line for TL/AD
+! AD test works without (x) and for xd = dxd*1.e5 : 2.79051851638 times the 0.
+! AD test does not work with the line : 754592404.083 times the 0.
+! problem seems to be linked to the largest dx wrt x
+!       x(i, k) = x(i, k) + dx
+!        x(i, k) = x(i, k) + dx         ! THIS LINE WAS COMMENTED OUT ORIGINALY !nhl
+        his_dh(i)=(1.-beta)*his_dh(i)
+      ENDDO 
+      ENDDO
+c
+      RETURN 
+      END
Index: LMDZ5/branches/testing/libf/phylmd/Dust/kg_to_cm3.F
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/Dust/kg_to_cm3.F	(revision 2641)
+++ LMDZ5/branches/testing/libf/phylmd/Dust/kg_to_cm3.F	(revision 2641)
@@ -0,0 +1,22 @@
+      SUBROUTINE kg_to_cm3(pplay,t_seri,tr_seri)
+c      
+      USE dimphy
+      USE infotrac
+      IMPLICIT NONE
+c
+#include "dimensions.h"
+#include "YOMCST.h"
+c      
+      REAL t_seri(klon,klev), pplay(klon,klev)
+      REAL tr_seri(klon,klev)
+      REAL zrho
+      INTEGER i, k
+c
+      DO k = 1, klev
+      DO i = 1, klon
+        zrho=pplay(i,k)/t_seri(i,k)/RD
+        tr_seri(i,k)=tr_seri(i,k)/1.e6*zrho
+      ENDDO
+      ENDDO
+c 
+      END
